<?php
defined('BASEPATH') or exit('No direct script access allowed');

class ParserDatabase
{

    //TODO: Functions return void

    protected $idLicitacion = 0;

    public function __construct()
    {
        $this->CI = &get_instance();
        $this->CI->load->model("Parser_model");
    }

    public function setDatosParser($arrayDatosSucios)
    {
        if (!empty($arrayDatosSucios)) {

            foreach ($arrayDatosSucios as $nombreArchivo => $datosArchivo) {
                guardar_log("setLicitacion", "ARCHIVO ---" . $nombreArchivo, false);

                foreach ($datosArchivo as $row) {
                    $idLicitacion = $this->setInicioLicitacion($row['general']);

                    if ($idLicitacion['result']) {
                        $this->idLicitacion = $idLicitacion['id'];

                        $this->setLegalDocs($row['legalDocs']);

                        $this->setTechnicalDocs($row['technicalDocs']);

                        $this->setGeneralDocs($row['generalDocs']);

                        $this->setAdditionalDocs($row['additionalDocs']);

                    }
                }
            }
        }
    }

    private function setInicioLicitacion($datosInicioLicitacion): array
    {
        $result = array("result" => false, "id" => 0);

        $insertLicitacion = $this->CI->Parser_model->setInicioLicitacion($datosInicioLicitacion);

        if ($insertLicitacion) {
            $result = array("result" => true, "id" => $insertLicitacion);
            guardar_log("setLicitacion", "Licitacion ID " . $datosInicioLicitacion['id_licitacion'] . " - BBDD Licitación ID " . $insertLicitacion, "false");
        } else {
            $result = array("result" => true, "id" => 0);
            guardar_log("setLicitacion", "Licitacion ID " . $datosInicioLicitacion['id_licitacion'], "false", 2);
        }

        return $result;
    }

    private function setLegalDocs($legalDocs): array
    {
        $result = array("result" => false, "id" => 0);
        $setInsert = array();
        $resultInsert = 0;

        if (!empty($legalDocs)) {
            $aux = 0;
            foreach ($legalDocs as $row) {
                $setInsert[$aux] = $row;
                $setInsert[$aux]['id_ajena_licitacion'] = $this->idLicitacion;
                $aux++;
            }

            if (!empty($setInsert)) {
                $resultInsert = insertBucle($setInsert, 'BRUTO_legal_documents', 'setLicitacion');
            }

            if ($resultInsert) {
                $result = array("result" => true);
                guardar_log("setLicitacion", "LegalDocs Finalizada Inserción", "false");
            } else {
                $result = array("result" => true, "id" => 0);
                guardar_log("setLicitacion", "LegalDocs Fallida", "false", 2);
            }
        } else {
            guardar_log("setLicitacion", "LegalDocs vacio", "false");
        }

        return $result;
    }

    private function setGeneralDocs($generalDocs): array
    {
        $result = array("result" => false, "id" => 0);
        $setInsert = array();
        $resultInsert = 0;
        if (!empty($generalDocs)) {
            $aux = 0;
            foreach ($generalDocs as $row) {
                $setInsert[$aux] = $row;
                $setInsert[$aux]['id_ajena_licitacion'] = $this->idLicitacion;
                $aux++;
            }

            if (!empty($setInsert)) {
                $resultInsert = insertBucle($setInsert, 'BRUTO_general_documents', 'setLicitacion');
            }

            if ($resultInsert) {
                $result = array("result" => true);
                guardar_log("setLicitacion", "GeneralDocs Finalizada Inserción", "false");
            } else {
                $result = array("result" => true, "id" => 0);
                guardar_log("setLicitacion", "GeneralDocs Fallida", "false", 2);
            }
        } else {
            guardar_log("setLicitacion", "GeneralDocs vacio", "false");
        }

        return $result;
    }

    private function setAdditionalDocs($additionalDocs): array
    {
        $result = array("result" => false, "id" => 0);
        $setInsert = array();
        $resultInsert = 0;
        if (!empty($additionalDocs)) {
            $aux = 0;
            foreach ($additionalDocs as $row) {
                $setInsert[$aux] = $row;
                $setInsert[$aux]['id_ajena_licitacion'] = $this->idLicitacion;
                $aux++;
            }

            if (!empty($setInsert)) {
                $resultInsert = insertBucle($setInsert, 'BRUTO_additional_documents', 'setLicitacion');
            }

            if ($resultInsert) {
                $result = array("result" => true);
                guardar_log("setLicitacion", "AdditionalDocs Finalizada Inserción", "false");
            } else {
                $result = array("result" => true, "id" => 0);
                guardar_log("setLicitacion", "AdditionalDocs Fallida", "false", 2);
            }
        } else {
            guardar_log("setLicitacion", "AdditionalDocs vacio", "false");
        }

        return $result;
    }

    private function setTechnicalDocs($technicalDocs): array
    {
        $result = array("result" => false, "id" => 0);
        $setInsert = array();
        $resultInsert = 0;
        if (!empty($technicalDocs)) {
            $aux = 0;
            foreach ($technicalDocs as $row) {
                $setInsert[$aux] = $row;
                $setInsert[$aux]['id_ajena_licitacion'] = $this->idLicitacion;
                $aux++;
            }

            if (!empty($setInsert)) {
                $resultInsert = insertBucle($setInsert, 'BRUTO_technical_documents', 'setLicitacion');
            }

            if ($resultInsert) {
                $result = array("result" => true);
                guardar_log("setLicitacion", "TechnicalDocs Finalizada Inserción", "false");
            } else {
                $result = array("result" => true, "id" => 0);
                guardar_log("setLicitacion", "TechnicalDocs Fallida", "false", 2);
            }
        } else {
            guardar_log("setLicitacion", "TechnicalDocs vacio", "false");
        }

        return $result;
    }

}

/* End of file ParserSetDatabase.php */
/* Location: ./application/libraries/ParserSetDatabase.php */
